<?php

require_once 'model/parametro.entidad.php';
require_once 'model/parametro.model.php';
require_once 'model/inventario.entidad.php';
require_once 'model/inventario.model.php';
require_once 'model/atencion.entidad.php';
require_once 'model/atencion.model.php';
require_once 'model/origendestino.entidad.php';
require_once 'model/origendestino.model.php';

class InventarioController extends MetodosController {

     private $parametro_model;
     private $inventario_model;
     private $atencion_model;
     public $origendestino_model;

     private $seguridad;

     public function __CONSTRUCT()
     {
          $this->parametro_model = new ParametroModel();
          $this->seguridad = new Seguridad();
          $this->inventario_model = new InventarioModel();
          $this->atencion_model = new AtencionModel();
          $this->origendestino_model = new OrigendestinoModel();
     }
     
     public function Index() {
          $parametro = $this->parametro_model->ListarParametros();
          $inventarios = $this->inventario_model->Listar();
          require_once 'view/header.php';
          require_once 'view/webforms/wfainventario.php';

          echo "<script type='text/javascript'>
                    $(document).ready(function (){
                         $('.taller').addClass('active');
                    });
               </script>";
          require_once 'view/footer.php';

     }

     public function FrmGuardarInventario() {
          $parametro = $this->parametro_model->ListarParametros();
          $atenciones = $this->atencion_model->Listar();
          $clientes = $this->origendestino_model->Listar();

          $OrdenTrabajo_Id = isset($_POST['OrdenTrabajo_Id']) ? $_POST['OrdenTrabajo_Id'] : '';

          $orden_trabajo = null;
          if (!empty($OrdenTrabajo_Id)) {
               $orden_trabajo = $this->atencion_model->Buscar($OrdenTrabajo_Id);
          }

          require_once 'view/webforms/wfainventarioa.php';

     }

     public function FrmEditarInventario() {
          $atenciones = $this->atencion_model->Listar();
          $OrdenTrabajo_Id = isset($_POST['OrdenTrabajo_Id']) ? $_POST['OrdenTrabajo_Id'] : '';
          $clientes = $this->origendestino_model->Listar();
          $datos = $this->inventario_model->Buscar($_POST['Inventario_Id']);
          foreach ($datos as $r) {
               require_once 'view/webforms/wfainventarioa.php';
          }
     }

     public function EliminarInventario() {
          $inv = new Inventario();
          $inv->__SET('Inventario_Id', $_POST['id_Inventario']);
          $inv->__SET('nInvUsuario_Id', $_SESSION['usu_codigo']);
          $this->inventario_model->Eliminar($inv);

          echo '<script type="text/javascript">window.location="?c=Inventario&a=Index";</script>';
     }

     public function ObtenerPathFirma($type, $post_param) {
          $uniquedId = uniqid();
		$fx = sprintf('./view/librerias/dist/firmas_img/%s_%s.png', $uniquedId, $type);
		if (preg_match('/^data/i', $post_param)) {
			$encoded_image = explode(",", $post_param)[1];
			$decoded_image = base64_decode($encoded_image);
			file_put_contents($fx, $decoded_image);
		} else if (preg_match('/clear/i', $post_param) || $post_param == '') {
			if (file_exists($fx)) {
				unlink($fx);
			}
			$fx = '';
		}
		return $fx;
	}


     public function uploadArchivo($file) {

          if ($file['error'] !== 0) {
               return ['error' => 'Error al subir la imagen'];
          }

          //Define la carpeta de destino donde se guardaran las imagenes
          $uploadDir = "view/librerias/dist/inventario_img/";
          if (!file_exists($uploadDir)) {
               mkdir($uploadDir, 0777, true);
          }

          //Obtener la info del archivo
          $filename = basename($file['name']);
          $fileExt = pathinfo($filename, PATHINFO_EXTENSION);
          $newFileName = pathinfo($filename, PATHINFO_FILENAME) . '.' . $fileExt;
          $targetFilePath = $uploadDir.$newFileName;

          if (file_exists($targetFilePath)) {
               unlink($targetFilePath);
          }

          if (move_uploaded_file($file['tmp_name'], $targetFilePath)) {
               return $targetFilePath;
          };
     }

     public function procesarImagen($archivo, $rutaActual) {
          // Verificar si se subió una nueva imagen
          if ($archivo && $archivo['error'] !== 4) {
              // Si existe una imagen anterior, eliminarla
              if ($rutaActual && file_exists($rutaActual)) {
                  unlink($rutaActual);
              }
              // Subir la nueva imagen y devolver la nueva ruta
              return $this->uploadArchivo($archivo);
          }
      
          // Si no se subió una nueva imagen, mantener la ruta anterior
          return $rutaActual;
      }


     public function GuardarInventario() {


          //FIRMAS
          $sInvFirmaReceptor = $this->ObtenerPathFirma('FirmaReceptor', $_POST['sInvFirmaReceptor']);
          $sInvFirmaEntregador = $this->ObtenerPathFirma('FirmaEntregador', $_POST['sInvFirmaEntregador']);

          //IMAGENES DE VEHICULOS
          $sInvVehiculoIng = $this->ObtenerPathFirma('IngresoVehiculo', $_POST['sInvVehiculoIng']);
          $sInvVehiculoSal = $this->ObtenerPathFirma('SalidaVehiculo', $_POST['sInvVehiculoSal']);

          // PARA GUARDADO Y EDICION DE LAS IMAGENES
          $sInvFotoIngresoActual = isset($_POST['sInvFotoIngresoActual']) ? $_POST['sInvFotoIngresoActual'] : null;
          $sInvFotoIngreso = isset($_FILES['sInvFotoIngreso']) && $_FILES['sInvFotoIngreso']['error'] !== 4 ? $_FILES['sInvFotoIngreso'] : null;
          $sInvFotoIngreso = $this->procesarImagen($sInvFotoIngreso, $sInvFotoIngresoActual);

          $sInvFoto1Actual = isset($_POST['sInvFoto1Actual']) ? $_POST['sInvFoto1Actual'] : null;
          $sInvFoto1 = isset($_FILES['sInvFoto1']) && $_FILES['sInvFoto1']['error'] !== 4 ? $_FILES['sInvFoto1'] : null;
          $sInvFoto1 = $this->procesarImagen($sInvFoto1, $sInvFoto1Actual);

          $sInvFoto2Actual = isset($_POST['sInvFoto2Actual']) ? $_POST['sInvFoto2Actual'] : null;
          $sInvFoto2 = isset($_FILES['sInvFoto2']) && $_FILES['sInvFoto2']['error'] !== 4 ? $_FILES['sInvFoto2'] : null;
          $sInvFoto2 = $this->procesarImagen($sInvFoto2, $sInvFoto2Actual);

          // $sInvVideoActual = isset($_POST['sInvVideoActual']) ? $_POST['sInvVideoActual'] : null;
          // $sInvVideo = isset($_FILES['sInvVideo']) && $_FILES['sInvVideo']['error'] !== 4 ? $_FILES['sInvVideo'] : null;
          // $sInvVideo = $this->procesarImagen($sInvVideo, $sInvVideoActual);

          $sInvFotoSalidaActual = isset($_POST['sInvFotoSalidaActual']) ? $_POST['sInvFotoSalidaActual'] : null;
          $sInvFotoSalida = isset($_FILES['sInvFotoSalida']) && $_FILES['sInvFotoSalida']['error'] !== 4 ? $_FILES['sInvFotoSalida'] : null;
          $sInvFotoSalida = $this->procesarImagen($sInvFotoSalida, $sInvFotoSalidaActual);


          $inv = new Inventario();
          if($_POST['Inventario_Id'] != 0 ? $inv->__SET('Inventario_Id', $_POST['Inventario_Id']) : '');
          $inv->__SET('OrdenTrabajo_Id', $_POST['OrdenTrabajo_Id']);
          $inv->__SET('dInvFechaIngreso', $_POST['dInvFechaIngreso']);
          $inv->__SET('dInvHoraIngreso', $_POST['dInvHoraIngreso']);
          $inv->__SET('sInvPlaca', $_POST['sInvPlaca']);
          $inv->__SET('sInvFotoIngreso', $sInvFotoIngreso);
          $inv->__SET('nInvKilometraje', $_POST['nInvKilometraje'] ? $_POST['nInvKilometraje'] : null);
          $inv->__SET('nInvHorometro', $_POST['nInvHorometro'] ? $_POST['nInvHorometro'] : null);
          $inv->__SET('nInvCliente_Id', $_POST['nInvCliente_Id']);
          $inv->__SET('nInvVehiculo_Id', $_POST['nInvVehiculo_Id']);
          $inv->__SET('nInvFarosDelanterosIng', $_POST['nInvFarosDelanterosIng']);
          $inv->__SET('nInvFarosDelanterosSal', $_POST['nInvFarosDelanterosSal']);
          $inv->__SET('sInvFarosDelanterosObs', $_POST['sInvFarosDelanterosObs']);
          $inv->__SET('nInvFarosPosterioresIng', $_POST['nInvFarosPosterioresIng']);
          $inv->__SET('nInvFarosPosterioresSal', $_POST['nInvFarosPosterioresSal']);
          $inv->__SET('sInvFarosPosterioresObs', $_POST['sInvFarosPosterioresObs']);
          $inv->__SET('nInvFarosNeblinerosIng', $_POST['nInvFarosNeblinerosIng']);
          $inv->__SET('nInvFarosNeblinerosSal', $_POST['nInvFarosNeblinerosSal']);
          $inv->__SET('sInvFarosNeblinerosObs', $_POST['sInvFarosNeblinerosObs']);
          $inv->__SET('nInvLucesDireccionalesIng', $_POST['nInvLucesDireccionalesIng']);
          $inv->__SET('nInvLucesDireccionalesSal', $_POST['nInvLucesDireccionalesSal']);
          $inv->__SET('sInvLucesDireccionalesObs', $_POST['sInvLucesDireccionalesObs']);
          $inv->__SET('nInvFarosPiratasIng', $_POST['nInvFarosPiratasIng']);
          $inv->__SET('nInvFarosPiratasSal', $_POST['nInvFarosPiratasSal']);
          $inv->__SET('sInvFarosPiratasObs', $_POST['sInvFarosPiratasObs']);
          $inv->__SET('nInvEspejosRetrovisoresIng', $_POST['nInvEspejosRetrovisoresIng']);
          $inv->__SET('nInvEspejosRetrovisoresSal', $_POST['nInvEspejosRetrovisoresSal']);
          $inv->__SET('sInvEspejosRetrovisoresObs', $_POST['sInvEspejosRetrovisoresObs']);
          $inv->__SET('nInvPlumillasIng', $_POST['nInvPlumillasIng']);
          $inv->__SET('nInvPlumillasSal', $_POST['nInvPlumillasSal']);
          $inv->__SET('sInvPlumillasObs', $_POST['sInvPlumillasObs']);
          $inv->__SET('nInvParabrisasDelanteraIng', $_POST['nInvParabrisasDelanteraIng']);
          $inv->__SET('nInvParabrisasDelanteraSal', $_POST['nInvParabrisasDelanteraSal']);
          $inv->__SET('sInvParabrisasDelanteraObs', $_POST['sInvParabrisasDelanteraObs']);
          $inv->__SET('nInvParabrisasPosteriorIng', $_POST['nInvParabrisasPosteriorIng']);
          $inv->__SET('nInvParabrisasPosteriorSal', $_POST['nInvParabrisasPosteriorSal']);
          $inv->__SET('sInvParabrisasPosteriorObs', $_POST['sInvParabrisasPosteriorObs']);
          $inv->__SET('nInvLunasLateralesIng', $_POST['nInvLunasLateralesIng']);
          $inv->__SET('nInvLunasLateralesSal', $_POST['nInvLunasLateralesSal']);
          $inv->__SET('sInvLunasLateralesObs', $_POST['sInvLunasLateralesObs']);
          $inv->__SET('nInvRadioIng', $_POST['nInvRadioIng']);
          $inv->__SET('nInvRadioSal', $_POST['nInvRadioSal']);
          $inv->__SET('sInvRadioObs', $_POST['sInvRadioObs']);
          $inv->__SET('nInvAireAcondicionadoIng', $_POST['nInvAireAcondicionadoIng']);
          $inv->__SET('nInvAireAcondicionadoSal', $_POST['nInvAireAcondicionadoSal']);
          $inv->__SET('sInvAireAcondicionadoObs', $_POST['sInvAireAcondicionadoObs']);
          $inv->__SET('nInvTarjetaPropiedadIng', $_POST['nInvTarjetaPropiedadIng']);
          $inv->__SET('nInvTarjetaPropiedadSal', $_POST['nInvTarjetaPropiedadSal']);
          $inv->__SET('sInvTarjetaPropiedadObs', $_POST['sInvTarjetaPropiedadObs']);
          $inv->__SET('nInvSoatIng', $_POST['nInvSoatIng']);
          $inv->__SET('nInvSoatSal', $_POST['nInvSoatSal']);
          $inv->__SET('sInvSoatObs', $_POST['sInvSoatObs']);
          $inv->__SET('nInvCinturonesSeguridadIng', $_POST['nInvCinturonesSeguridadIng']);
          $inv->__SET('nInvCinturonesSeguridadSal', $_POST['nInvCinturonesSeguridadSal']);
          $inv->__SET('sInvCinturonesSeguridadObs', $_POST['sInvCinturonesSeguridadObs']);
          $inv->__SET('nInvExtintorIng', $_POST['nInvExtintorIng']);
          $inv->__SET('nInvExtintorSal', $_POST['nInvExtintorSal']);
          $inv->__SET('sInvExtintorObs', $_POST['sInvExtintorObs']);
          $inv->__SET('nInvTrianguloSeguridadIng', $_POST['nInvTrianguloSeguridadIng']);
          $inv->__SET('nInvTrianguloSeguridadSal', $_POST['nInvTrianguloSeguridadSal']);
          $inv->__SET('sInvTrianguloSeguridadObs', $_POST['sInvTrianguloSeguridadObs']);
          $inv->__SET('nInvGataPalancaIng', $_POST['nInvGataPalancaIng']);
          $inv->__SET('nInvGataPalancaSal', $_POST['nInvGataPalancaSal']);
          $inv->__SET('sInvGataPalancaObs', $_POST['sInvGataPalancaObs']);
          $inv->__SET('nInvLlaveRuedasIng', $_POST['nInvLlaveRuedasIng']);
          $inv->__SET('nInvLlaveRuedasSal', $_POST['nInvLlaveRuedasSal']);
          $inv->__SET('sInvLlaveRuedasObs', $_POST['sInvLlaveRuedasObs']);
          $inv->__SET('nInvAntenaRadioIng', $_POST['nInvAntenaRadioIng']);
          $inv->__SET('nInvAntenaRadioSal', $_POST['nInvAntenaRadioSal']);
          $inv->__SET('sInvAntenaRadioObs', $_POST['sInvAntenaRadioObs']);
          $inv->__SET('nInvLlantaRepuestoIng', $_POST['nInvLlantaRepuestoIng']);
          $inv->__SET('nInvLlantaRepuestoSal', $_POST['nInvLlantaRepuestoSal']);
          $inv->__SET('sInvLlantaRepuestoObs', $_POST['sInvLlantaRepuestoObs']);
          $inv->__SET('sInvFoto1', $sInvFoto1);
          $inv->__SET('sInvFoto2', $sInvFoto2);
          $inv->__SET('sInvVideo', ''); //$sInvVideo
          
          $inv->__SET('sInvVehiculoIng', $sInvVehiculoIng); //$_POST['sInvVehiculoIng']
          $inv->__SET('sInvTanqueCombustibleIng', $_POST['sInvTanqueCombustibleIng']); //$_POST['sInvTanqueCombustibleSal']
          $inv->__SET('sInvVehiculoSal', $sInvVehiculoSal); //$_POST['sInvVehiculoSal']
          $inv->__SET('sInvTanqueCombustibleSal', $_POST['sInvTanqueCombustibleSal']); //$_POST['sInvTanqueCombustibleSal']

          $inv->__SET('dInvFechaSalida', $_POST['dInvFechaSalida']);
          $inv->__SET('dInvHoraSalida', $_POST['dInvHoraSalida']);
          $inv->__SET('sInvFotoSalida', $sInvFotoSalida);

          $inv->__SET('sInvNombreReceptor', $_POST['sInvNombreReceptor']);
          $inv->__SET('sInvCelularReceptor', $_POST['sInvCelularReceptor']);
          $inv->__SET('sInvFirmaReceptor', $sInvFirmaReceptor);

          $inv->__SET('sInvNombreEntregador', $_POST['sInvNombreEntregador']);
          $inv->__SET('sInvCelularEntregador', $_POST['sInvCelularEntregador']);
          $inv->__SET('sInvFirmaEntregador', $sInvFirmaEntregador);

          $inv->__SET('nInvEliminado', 0);
          $inv->__SET('nInvUsuario_Id', $_SESSION['usu_codigo']);
          $inv->__SET('nInvEstado', 1);

          $result = $_POST['Inventario_Id'] != 0 ? $this->inventario_model->Editar($inv) : $this->inventario_model->Guardar($inv);

          $response = [
               'success' => true,
               'html' => '<div class="alert alert-success" role="alert">
                              <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                              <strong>Los datos fueron Guardados exitosamente</strong>
                         </div>'
          ];

          echo json_encode($response);

     }

     public function PDFInventario() {
          include 'model/helpers.php';

          //Obtener el inventario completo
          $inventario = $this->inventario_model->Buscar($_REQUEST['Inventario_Id']);
          
          foreach ($inventario as $r) {
               include 'view/webforms/PDF/inventarioImprimir.php';
          }
     }


}


?>