<?php

require_once 'model/parametro.entidad.php';
require_once 'model/parametro.model.php';
require_once 'model/origendestino.entidad.php';
require_once 'model/origendestino.model.php';
require_once 'model/vehiculo.entidad.php';
require_once 'model/vehiculo.model.php';

class VehiculoController {

     private $parametro_model;
     private $origendestino_model;
     private $vehiculo_model;

     private $seguridad;

     public function __CONSTRUCT()
     {
         $this->parametro_model = new ParametroModel();
         $this->origendestino_model = new OrigendestinoModel();
         $this->vehiculo_model = new VehiculoModel();

         $this->seguridad = new Seguridad();
 
     }
     
     public function Index() {
          
          $parametro = $this->parametro_model->ListarParametros();
          $vehiculos = $this->vehiculo_model->Listar();
          require_once 'view/header.php';
          require_once 'view/webforms/wfavehiculo.php';

          echo "<script type='text/javascript'>
                    $(document).ready(function (){
                         $('.taller').addClass('active');
                    });
               </script>";
          require_once 'view/footer.php';

     }

     public function GuardarVehiculo() {
          $veh = new Vehiculo();

          if($_POST['vehiculo_Id'] != 0 ? $veh->__SET('vehiculo_Id', $_POST['vehiculo_Id']) : '');

          $veh->__SET('sVehCodigo', $_POST['sVehCodigo']);
          $veh->__SET('nVehCliente_Id', $_POST['nVehCliente_Id']);
          $veh->__SET('sVehTipoVeh', $_POST['sVehTipoVeh']);
          $veh->__SET('sVehCategoria', $_POST['sVehCategoria']);
          $veh->__SET('sVehNSerie', $_POST['sVehNSerie']);
          $veh->__SET('sVehPlaca', $_POST['sVehPlaca']);
          $veh->__SET('sVehCodigoVin', $_POST['sVehCodigoVin']);
          $veh->__SET('dVehAFabricacion', $_POST['dVehAFabricacion']);
          $veh->__SET('dVehFGarantia', $_POST['dVehFGarantia']);
          $veh->__SET('sVehModelo', $_POST['sVehModelo']);
          $veh->__SET('sVehModDiferencial', $_POST['sVehModDiferencial']);
          $veh->__SET('sVehMotor', $_POST['sVehMotor']);
          $veh->__SET('sVehMarca', $_POST['sVehMarca']);
          $veh->__SET('sVehMarcaDiferencial', $_POST['sVehMarcaDiferencial']);
          $veh->__SET('sVehActividad', $_POST['sVehActividad']);
          $veh->__SET('sVehConfiguracion', $_POST['sVehConfiguracion']);
          $veh->__SET('dVehVencSoat', $_POST['dVehVencSoat']);
          $veh->__SET('dVehVencPoliza', $_POST['dVehVencPoliza']);
          $veh->__SET('dVehCertInspTec', $_POST['dVehCertInspTec']);
          $veh->__SET('dVehVencCertMtc', $_POST['dVehVencCertMtc']);
          $veh->__SET('sVehDescripcion', $_POST['sVehDescripcion']);
          
          $veh->__SET('nVehTipoFlota', $_POST['nVehTipoFlota']);
          $veh->__SET('sVehTipoUso', $_POST['sVehTipoUso']);
          $veh->__SET('sVehTipoCaja', $_POST['sVehTipoCaja']);
          $veh->__SET('sVehMarcaCaja', $_POST['sVehMarcaCaja']);
          $veh->__SET('sVehModCaja', $_POST['sVehModCaja']);
          $veh->__SET('sVehFrecServ', $_POST['sVehFrecServ']);
          $veh->__SET('sVehTipoComb', $_POST['sVehTipoComb']);
          $veh->__SET('sVehTarjComb', $_POST['sVehTarjComb']);
          $veh->__SET('sVehCargaUtil', $_POST['sVehCargaUtil']);
          $veh->__SET('sVehtransmision', $_POST['sVehtransmision']);
          $veh->__SET('sVehTipoTraccion', $_POST['sVehTipoTraccion']);
          $veh->__SET('sVehModeloTraccion', $_POST['sVehModeloTraccion']);
          $veh->__SET('sVehTipoCarroceria', $_POST['sVehTipoCarroceria']);
          $veh->__SET('sVeColor', $_POST['sVeColor']);
          $veh->__SET('sVehNejes', $_POST['sVehNejes'] ? $_POST['sVehNejes'] : 0);
          $veh->__SET('sVehNruedas', $_POST['sVehNruedas'] ? $_POST['sVehNruedas'] : 0);
          $veh->__SET('sVehMedRuedas', $_POST['sVehMedRuedas']);
          $veh->__SET('sVehNPuertas', $_POST['sVehNPuertas'] ? $_POST['sVehNPuertas'] : 0);
          $veh->__SET('sVehNAsientos', $_POST['sVehNAsientos'] ? $_POST['sVehNAsientos'] : 0);
          $veh->__SET('nVehCTechos', $_POST['nVehCTechos']);
          $veh->__SET('sVehNCompartimientos', $_POST['sVehNCompartimientos'] ? $_POST['sVehNCompartimientos']: 0);
          $veh->__SET('sVehNPasajeros', $_POST['sVehNPasajeros'] ? $_POST['sVehNPasajeros'] : 0);
          $veh->__SET('nVehEstado', 1);
          $veh->__SET('nVehElimimado', 0);
          $veh->__SET('nVehUsuario_Id', $_SESSION['usu_codigo']);

          if($_POST['vehiculo_Id'] != 0 ? $this->vehiculo_model->Editar($veh) : $this->vehiculo_model->guardar($veh));

     }

     public function FrmGuardarVehiculo() {
          include 'model/helpers.php';
          $clientes = $this->origendestino_model->Listar();
          require_once 'view/webforms/wfavehiculoa.php';
     }

     public function FrmEditarVehiculo() {
          include 'model/helpers.php';
          $clientes = $this->origendestino_model->Listar();
          $datos = $this->vehiculo_model->Buscar($_POST['vehiculo_Id']);
          foreach ($datos as $r) {
               require_once 'view/webforms/wfavehiculoa.php';
          }
     }

     public function EliminarVehiculo() {
         $veh = new Vehiculo();
         $veh->__SET('vehiculo_Id', $_POST['idVehiculo']);
         $veh->__SET('nVehUsuario_Id', $_SESSION['usu_codigo']);

         $this->vehiculo_model->Eliminar($veh);

         echo '<script type="text/javascript">window.location="?c=Vehiculo&a=Index";</script>';
     }

     public function MostrarVehiculo(){
          include 'model/helpers.php';
          $idVehiculo = isset($_POST['vehiculo_Id']) ? $_POST['vehiculo_Id'] : '';
          $vehiculo = $this->vehiculo_model->Buscar($idVehiculo);
          $r = $vehiculo[0];

          $IsTecho = $r->__GET('nVehCTechos') == 1 ? 'Si' : 'No';

          echo '<table class="table table-hover table-bordered">';

               echo '<thead>';
                    echo '<tr>';
                         echo '<th colspan="2" class="text-center bg-primary text-white" style="width: 50%;">Datos del Vehículo</th>';
                         echo '<th colspan="2" class="text-center bg-yellow text-white" style="width: 50%;">Otros Datos</th>';
                    echo '</tr>';
               echo '</thead>';

               echo '<tbody>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Codigo: </td>';
                         echo '<td>'. $r->__GET('sVehCodigo') .'</td>';

                         echo '<td style="font-weight: bold;"> Tipo Uso: </td>';
                         echo '<td>'. $r->__GET('sVehTipoUso').'</td>';

                    echo '</tr>';
                    echo '<tr>';

                         echo '<td style="font-weight: bold;"> Cliente: </td>';
                         echo '<td>'. $r->__GET('sODNombre') .'</td>';

                         echo '<td style="font-weight: bold;"> Tipo Caja: </td>';
                         echo '<td>'. $r->__GET('sVehTipoCaja').'</td>';

                    echo '</tr>';
                    echo '<tr>';

                         echo '<td style="font-weight: bold;"> Tipo Flota: </td>';
                         echo '<td>'. getDescripcionById($flotas, $r->__GET('nVehTipoFlota')) .'</td>';

                         echo '<td style="font-weight: bold;"> Marca de la Caja: </td>';
                         echo '<td>'. $r->__GET('sVehMarcaCaja').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Tipo Vehiculo: </td>';
                         echo '<td>'. $r->__GET('sVehTipoVeh') .'</td>';

                         echo '<td style="font-weight: bold;"> Modelo de la Caja: </td>';
                         echo '<td>'. $r->__GET('sVehModCaja').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Tipo Categoría: </td>';
                         echo '<td>'. $r->__GET('sVehCategoria') .'</td>';

                         echo '<td style="font-weight: bold;"> Frecuencia del servicio: </td>';
                         echo '<td>'. $r->__GET('sVehFrecServ').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Serie: </td>';
                         echo '<td>'. $r->__GET('sVehNSerie') .'</td>';

                         echo '<td style="font-weight: bold;"> Tipo de Combustible: </td>';
                         echo '<td>'. $r->__GET('sVehTipoComb').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Placa: </td>';
                         echo '<td>'. $r->__GET('sVehPlaca') .'</td>';

                         echo '<td style="font-weight: bold;"> Tarjeta de Combustible: </td>';
                         echo '<td>'. $r->__GET('sVehTarjComb').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Código VIN: </td>';
                         echo '<td>'. $r->__GET('sVehCodigoVin') .'</td>';

                         echo '<td style="font-weight: bold;"> Carga Útil: </td>';
                         echo '<td>'. $r->__GET('sVehCargaUtil').' Kg </td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Año de Fabricación: </td>';
                         echo '<td>'. $r->__GET('dVehAFabricacion') .'</td>';

                         echo '<td style="font-weight: bold;"> Transmisión: </td>';
                         echo '<td>'. $r->__GET('sVehtransmision').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Fecha de Garantía: </td>';
                         echo '<td>'. date('d-m-Y', strtotime($r->__GET('dVehFGarantia'))).'</td>';

                         echo '<td style="font-weight: bold;"> Tipo Tracción: </td>';
                         echo '<td>'. $r->__GET('sVehTipoTraccion').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Modelo: </td>';
                         echo '<td>'. $r->__GET('sVehModelo').'</td>';

                         echo '<td style="font-weight: bold;"> Tipo Carrocería: </td>';
                         echo '<td>'. $r->__GET('sVehTipoCarroceria').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Modelo Diferencial: </td>';
                         echo '<td>'. $r->__GET('sVehModDiferencial').'</td>';

                         echo '<td style="font-weight: bold;"> Color: </td>';
                         echo '<td>'. $r->__GET('sVeColor').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Motor: </td>';
                         echo '<td>'. $r->__GET('sVehMotor').'</td>';

                         echo '<td style="font-weight: bold;"> N° de Ejes: </td>';
                         echo '<td>'. $r->__GET('sVehNejes').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Marca: </td>';
                         echo '<td>'. $r->__GET('sVehMarca').'</td>';

                         echo '<td style="font-weight: bold;"> N° de Ruedas: </td>';
                         echo '<td>'. $r->__GET('sVehNruedas').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Marca Diferencial: </td>';
                         echo '<td>'. $r->__GET('sVehMarcaDiferencial').'</td>';

                         echo '<td style="font-weight: bold;"> Medida Ruedas: </td>';
                         echo '<td>'. $r->__GET('sVehMedRuedas').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Actividad: </td>';
                         echo '<td>'. $r->__GET('sVehActividad').'</td>';

                         echo '<td style="font-weight: bold;"> N° de Puertas: </td>';
                         echo '<td>'. $r->__GET('sVehNPuertas').'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Configuración: </td>';
                         echo '<td>'. $r->__GET('sVehConfiguracion').'</td>';

                         echo '<td style="font-weight: bold;"> N° de Asientos: </td>';
                         echo '<td>'. $r->__GET('sVehNAsientos') .'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Fecha de Vencimiento SOAT: </td>';
                         echo '<td>'. date('d-m-Y', strtotime($r->__GET('dVehVencSoat'))).'</td>';

                         echo '<td style="font-weight: bold;"> Vehículo con Techo: </td>';
                         echo '<td>'. $IsTecho .'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Fecha de Vencimiento Poliza: </td>';
                         echo '<td>'. date('d-m-Y', strtotime($r->__GET('dVehVencPoliza'))).'</td>';

                         echo '<td style="font-weight: bold;"> N° de Compartimientos: </td>';
                         echo '<td>'. $r->__GET('sVehNCompartimientos') .'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Certificado de Inspección: </td>';
                         echo '<td>'. date('d-m-Y', strtotime($r->__GET('dVehCertInspTec'))).'</td>';

                         echo '<td style="font-weight: bold;"> N° de Pasajeros: </td>';
                         echo '<td>'. $r->__GET('sVehNPasajeros') .'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Vencimiento Certificado MTC: </td>';
                         echo '<td>'. date('d-m-Y', strtotime($r->__GET('dVehVencCertMtc'))).'</td>';

                    echo '</tr>';
                    echo '<tr>';
                         echo '<td style="font-weight: bold;"> Descripción: </td>';
                         echo '<td>'. $r->__GET('sVehDescripcion').'</td>';

                    echo '</tr>';
               echo '</tbody>';

          echo '</table>';
     }

}


?>