<?php

class AtencionModel {

    private $pdo;

    public function __CONSTRUCT(){
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ord_listarC(0)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $ord = new Atencion();
                $ord->__SET('OrdenTrabajo_Id', $r->OrdenTrabajo_Id);
                $ord->__SET('sOtNumOrden', $r->sOtNumOrden);
                $ord->__SET('sOtCliente_Id', $r->sOtCliente_Id);
                $ord->__SET('sODNombre', $r->sODNombre);
                $ord->__SET('sOtVehiculo_Id', $r->sOtVehiculo_Id);
                $ord->__SET('sVehModelo', $r->sVehModelo);
                $ord->__SET('dOtFi', $r->dOtFi);
                $ord->__SET('dOtHi', $r->dOtHi);
                $ord->__SET('dOtFs', $r->dOtFs);
                $ord->__SET('dOtHs', $r->dOtHs);
                $ord->__SET('nOtTipoMant', $r->nOtTipoMant);
                $ord->__SET('sOtMotMant', $r->sOtMotMant);
                $ord->__SET('nOtTipoAtencion', $r->nOtTipoAtencion);
                $ord->__SET('nOtEstado', $r->nOtEstado);
                $ord->__SET('nOtKilometraje', $r->nOtKilometraje);
                $ord->__SET('nOtHorometro', $r->nOtHorometro);
                $ord->__SET('sOtRecomendaciones', $r->sOtRecomendaciones);
                
                $result[] = $ord;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($ordenTrabajo_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ord_listarC($ordenTrabajo_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $ord = new Atencion();
                $ord->__SET('OrdenTrabajo_Id', $r->OrdenTrabajo_Id);
                $ord->__SET('sOtNumOrden', $r->sOtNumOrden);
                $ord->__SET('sOtCliente_Id', $r->sOtCliente_Id);
                $ord->__SET('sOtVehiculo_Id', $r->sOtVehiculo_Id);
                $ord->__SET('dOtFi', $r->dOtFi);
                $ord->__SET('dOtHi', $r->dOtHi);
                $ord->__SET('dOtFs', $r->dOtFs);
                $ord->__SET('dOtHs', $r->dOtHs);
                $ord->__SET('nOtTipoMant', $r->nOtTipoMant);
                $ord->__SET('sOtMotMant', $r->sOtMotMant);
                $ord->__SET('nOtTipoAtencion', $r->nOtTipoAtencion);
                $ord->__SET('nOtEstado', $r->nOtEstado);
                $ord->__SET('nOtEliminado', $r->nOtEliminado);
                $ord->__SET('dOtFech_Act', $r->dOtFech_Act);
                $ord->__SET('nOtUsuario_Id', $r->nOtUsuario_Id);
                $ord->__SET('nOtKilometraje', $r->nOtKilometraje);
                $ord->__SET('nOtHorometro', $r->nOtHorometro);
                $ord->__SET('sOtRecomendaciones', $r->sOtRecomendaciones);

                $ord->__SET('sODNombre', $r->sODNombre);
                $ord->__SET('sVehModelo', $r->sVehModelo);

                $result[] = $ord;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarxMantenimiento($idTipoMantenimiento){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ord_listarxmantenimiento(?)");
            $stm->execute([$idTipoMantenimiento]);

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $ord = new Atencion();
                $ord->__SET('OrdenTrabajo_Id', $r->OrdenTrabajo_Id);
                $ord->__SET('sOtNumOrden', $r->sOtNumOrden);
                $ord->__SET('sOtCliente_Id', $r->sOtCliente_Id);
                $ord->__SET('sODNombre', $r->sODNombre);
                $ord->__SET('sOtVehiculo_Id', $r->sOtVehiculo_Id);
                $ord->__SET('sVehModelo', $r->sVehModelo);
                $ord->__SET('dOtFi', $r->dOtFi);
                $ord->__SET('dOtHi', $r->dOtHi);
                $ord->__SET('dOtFs', $r->dOtFs);
                $ord->__SET('dOtHs', $r->dOtHs);
                $ord->__SET('nOtTipoMant', $r->nOtTipoMant);
                $ord->__SET('sOtMotMant', $r->sOtMotMant);
                $ord->__SET('nOtTipoAtencion', $r->nOtTipoAtencion);
                $ord->__SET('nOtEstado', $r->nOtEstado);
                $ord->__SET('nOtKilometraje', $r->nOtKilometraje);
                $ord->__SET('nOtHorometro', $r->nOtHorometro);
                $ord->__SET('sOtRecomendaciones', $r->sOtRecomendaciones);
                
                $result[] = $ord;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(Atencion $data){
        try {
            $OrdenTrabajo_Id = 0;
            $stm = $this->pdo->prepare("CALL ord_crear(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,@ordenTrabajoId)");
            $stm->execute(array(
                                $data->__get('sOtNumOrden'),
                                $data->__get('sOtCliente_Id'),
                                $data->__get('sOtVehiculo_Id'),
                                $data->__get('dOtFi'),
                                $data->__get('dOtHi'),
                                $data->__get('dOtFs'),
                                $data->__get('dOtHs'),
                                $data->__get('nOtTipoMant'),
                                $data->__get('sOtMotMant'),
                                $data->__get('nOtTipoAtencion'),
                                $data->__get('nOtEstado'),
                                $data->__get('nOtEliminado'),
                                $data->__get('dOtFech_Act'),
                                $data->__get('nOtUsuario_Id'),
                                $data->__get('nOtKilometraje'),
                                $data->__get('nOtHorometro'),
                                $data->__get('sOtRecomendaciones')
                         ));

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $OrdenTrabajo_Id = $r->OrdenTrabajo_Id;
            }

            return $OrdenTrabajo_Id;

        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Editar(Atencion $data){
        try {
            $stm = $this->pdo->prepare("CALL ord_editar(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                            $data->__get('OrdenTrabajo_Id'),
                            $data->__get('sOtNumOrden'),
                            $data->__get('sOtCliente_Id'),
                            $data->__get('sOtVehiculo_Id'),
                            $data->__get('dOtFi'),
                            $data->__get('dOtHi'),
                            $data->__get('dOtFs'),
                            $data->__get('dOtHs'),
                            $data->__get('nOtTipoMant'),
                            $data->__get('sOtMotMant'),
                            $data->__get('nOtTipoAtencion'),
                            $data->__get('nOtEstado'),
                            $data->__get('nOtEliminado'),
                            $data->__get('dOtFech_Act'),
                            $data->__get('nOtUsuario_Id'),
                            $data->__get('nOtKilometraje'),
                            $data->__get('nOtHorometro'),
                            $data->__get('sOtRecomendaciones')
                    )); 

        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function Eliminar(Atencion $data){
        try {
            $stm = $this->pdo->prepare("CALL ord_ocultar(?,?)");
            $stm->execute(array(
                                $data->__get('OrdenTrabajo_Id'),
                                $data->__get('nOtUsuario_Id')
                            ));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }



    // FUNCIONES PARA AGREGAR LA ATENCION INTERNA
    public function BuscarOrdenInterna($OrdenInternaId) {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL ordint_listarBuscar(?)');
            $stm->execute([$OrdenInternaId]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ateInt = new AtencionInterna();
                $ateInt->__SET('OrdenTrabajoInterno_Id', $r->OrdenTrabajoInterno_Id);
                $ateInt->__SET('nOtiOrdenTrabajo_Id', $r->nOtiOrdenTrabajo_Id);
                $ateInt->__SET('nOtiCantidad', $r->nOtiCantidad);
                $ateInt->__SET('nOtiSistema_Id', $r->nOtiSistema_Id);
                $ateInt->__SET('nOtiTarea_Id', $r->nOtiTarea_Id);
                $ateInt->__SET('nOtiPersonal_Id', $r->nOtiPersonal_Id);
                $ateInt->__SET('sOtiTiempo', $r->sOtiTiempo);
                $ateInt->__SET('sOtiDescripcion', $r->sOtiDescripcion);
                $ateInt->__SET('sOtiFotografia', $r->sOtiFotografia);
                $ateInt->__SET('nOtiEliminado', $r->nOtiEliminado);
                $ateInt->__SET('dOtiFecha_Act', $r->dOtiFecha_Act);
                $ateInt->__SET('nOtiUsuario_Id', $r->nOtiUsuario_Id);

                $ateInt->__SET('sSisNombre', $r->sSisNombre);
                $ateInt->__SET('sTarNombre', $r->sTarNombre);
                $ateInt->__SET('sPerApellidos', $r->sPerApellidos);
                $ateInt->__SET('sPerNombres', $r->sPerNombres);
                
                $result[] = $ateInt;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ListarOrdenesInternas($ordenId) {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL ordint_listarC(?)');
            $stm->execute([$ordenId]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function GuardarOrdenInterna($idOrden, $cantidad, $sistemaId, $tiempo, $tareaId, $personalId, $descripcion, $fotografia, $usuario) {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL ordint_crear(?,?,?,?,?,?,?,?,?)');
            $stm->execute([$idOrden, $cantidad, $sistemaId, $tiempo, $tareaId, $personalId, $descripcion, $fotografia, $usuario]);

            // foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
            //     $result[] = $r;
            // }
            // return $result;

        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function EditarOrdenInterna($id, $idOrden, $cantidad, $sistemaId, $tiempo, $tareaId, $personalId, $descripcion, $fotografia, $usuario) {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL OD_editarordeninterna(?,?,?,?,?,?,?,?,?,?)');
            $stm->execute([$id, $idOrden, $cantidad, $sistemaId, $tiempo, $tareaId, $personalId, $descripcion, $fotografia, $usuario]);

            // foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
            //     $result[] = $r;
            // }
            // return $result;

        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function OcultarAtencionInterna($id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare('UPDATE ordentrabajointerno SET nOtiEliminado=1 WHERE OrdenTrabajoInterno_Id = ?');
            $stm->execute([$id]);
            
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }


    //FUNCIONES PARA LOS TRABAJOS INTERNOS
    public function ListarTrabajosExternos($tipoMovimiento, $ordenId) {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL mov_listarxordenes(?,?)');
            $stm->execute([$tipoMovimiento, $ordenId]);

            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Movimiento();
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $mov->__SET('sTMovNombre', $r->sTMovNombre);
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('sODNombreComercial', $r->sODNombreComercial);
                $mov->__SET('sAlmNombre', $r->sAlmNombre);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovTotal);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('isFE', $r->isFE);
                $mov->__SET('nMovOrdenCompra_Id', $r->nMovOrdenCompra_Id);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);
                $mov->__SET('OrdenTrabajo_Id', $r->OrdenTrabajo_Id);

                $datemovimiento = new DateTime($r->dMovFecha);
                $mov->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ListarCotizacionesOrdenes($ordenId) {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL cot_listarxordenes(?)');
            $stm->execute([$ordenId]);
            $datecurrent = new DateTime(date('Y-m-d'));

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Cotizacion();
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('dMovFechaCotizacion', date('d-m-Y', strtotime($r->dMovFechaCotizacion)));
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('sODNombreComercial', $r->sODNombreComercial);
                $mov->__SET('sAlmNombre', $r->sAlmNombre);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovDescuento', $r->nMovDescuento);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovTotal);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('isFE', $r->isFE);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);
                $mov->__SET('OrdenTrabajo_Id', $r->OrdenTrabajo_Id);
                
                $mov->__SET('sMovAsesor', $r->sMovAsesor);
                $mov->__SET('sMovLugarEnrtega', $r->sMovLugarEnrtega);
                $mov->__SET('nMovGarantia', $r->nMovGarantia);
                $mov->__SET('nMovTiempoEntrega', $r->nMovTiempoEntrega);
                $mov->__SET('nMovValidezOferta', $r->nMovValidezOferta);

                $datemovimiento = new DateTime($r->dMovFecha);
                $mov->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ListarInventariosOrdenes($ordenId) {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL Inv_ListarOrdenes(?)');
            $stm->execute([$ordenId]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ObtenerNumeroOtxDoc($Documento_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT * FROM documento where Documento_Id = ? ");
            $stm->execute([$Documento_Id]);
            $r = $stm->fetch(PDO::FETCH_OBJ);
            return $r;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    

}