<?php 
class PersonalModel {
    private $pdo;
    public function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL per_listarC(0)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $per = new Personal();
                $per->__SET('Personal_Id', $r->Personal_Id);
                $per->__SET('nPerDni', $r->nPerDni);
                $per->__SET('sPerApellidos', $r->sPerApellidos);
                $per->__SET('sPerNombres', $r->sPerNombres);
                $per->__SET('sPerCargo', $r->sPerCargo);
                $per->__SET('sPerCargo', $r->sPerCargo);
                $per->__SET('sPerArea', $r->sPerArea);
                $per->__SET('nPerEstado', $r->nPerEstado);
                $result[] = $per;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($Personal_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL per_listarC($Personal_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $per = new Personal();
                $per->__SET('Personal_Id', $r->Personal_Id);
                $per->__SET('nPerDni', $r->nPerDni);
                $per->__SET('sPerApellidos', $r->sPerApellidos);
                $per->__SET('sPerNombres', $r->sPerNombres);
                $per->__SET('sPerCargo', $r->sPerCargo);
                $per->__SET('sPerArea', $r->sPerArea);
                $per->__SET('nPerEliminado', $r->nPerEliminado);
                $per->__SET('dPerFecha_Act', $r->dPerFecha_Act);
                $per->__SET('nPerUsuario_Id', $r->nPerUsuario_Id);
                $per->__SET('nPerEstado', $r->nPerEstado);
                $result[] = $per;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(Personal $data){
        try {
            $stm = $this->pdo->prepare("CALL per_crear(?,?,?,?,?,?,?,?,@PersonalId)");
            $stm->execute(array(
                                $data->__get('nPerDni'),
                                $data->__get('sPerApellidos'),
                                $data->__get('sPerNombres'),
                                $data->__get('sPerCargo'),
                                $data->__get('sPerArea'),
                                $data->__get('nPerEliminado'),
                                $data->__get('nPerUsuario_Id'),
                                $data->__get('nPerEstado')
                         ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>    <i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                    La informacion fue registrada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Editar(Personal $data){
        try {
            $stm = $this->pdo->prepare("CALL per_editar(?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('Personal_Id'),
                                 $data->__get('nPerDni'),
                                 $data->__get('sPerApellidos'),
                                 $data->__get('sPerNombres'),
                                 $data->__get('sPerCargo'),
                                 $data->__get('sPerArea'),
                                 $data->__get('nPerEliminado'),
                                 $data->__get('nPerUsuario_Id'),
                                 $data->__get('nPerEstado')
                                ));
            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>    <i class="icon fa fa-check"></i> Exito, </h4>
                    Se modifico correctamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Eliminar(Personal $data){
        try {
            $stm = $this->pdo->prepare("CALL per_ocultar(?,?)");
            $stm->execute(array($data->__GET('Personal_Id'), $data->__GET('nPerUsuario_Id')));     
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function BuscarxDni($dni) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT * FROM personal where nPerDni = ?");
            $stm->execute([$dni]); 
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $result[] = $r;
            }
            return $result;    
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}