<?php
class TareasModel {
    
    private $pdo;

    public function __CONSTRUCT(){
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL tar_listarC(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $tar = new Tareas();
                $tar->__SET('Tareas_Id', $r->Tareas_Id);
                $tar->__SET('sTarCodigo', $r->sTarCodigo);
                $tar->__SET('sTarNombre', $r->sTarNombre);
                $tar->__SET('nTarTipoFlota', $r->nTarTipoFlota);
                $tar->__SET('sTarSistema_Id', $r->sTarSistema_Id);
                $tar->__SET('sSiscodigo', $r->sSiscodigo);
                $tar->__SET('sSisNombre', $r->sSisNombre);
                $tar->__SET('sTarTiempoStandard', $r->sTarTiempoStandard);
                $tar->__SET('nTarValorVenta', $r->nTarValorVenta);
                $tar->__SET('nTarEstado', $r->nTarEstado);
                $result[] = $tar;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($Tarea_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL tar_listarC($Tarea_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $tar = new Tareas();
                $tar->__SET('Tareas_Id', $r->Tareas_Id);
                $tar->__SET('sTarCodigo', $r->sTarCodigo);
                $tar->__SET('sTarNombre', $r->sTarNombre);
                $tar->__SET('nTarTipoFlota', $r->nTarTipoFlota);
                $tar->__SET('sTarSistema_Id', $r->sTarSistema_Id);
                $tar->__SET('sSiscodigo', $r->sSiscodigo);
                $tar->__SET('sSisNombre', $r->sSisNombre);
                $tar->__SET('sTarTiempoStandard', $r->sTarTiempoStandard);
                $tar->__SET('nTarValorVenta', $r->nTarValorVenta);
                $tar->__SET('nTarEstado', $r->nTarEstado);
                $tar->__SET('nTarEliminado', $r->nTarEliminado);
                $tar->__SET('dFech_Act', $r->dFech_Act);
                $tar->__SET('nTarUsuario_Id', $r->nTarUsuario_Id);
                $result[] = $tar;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(Tareas $data){
        try {
            $stm = $this->pdo->prepare("CALL tar_crear(?,?,?,?,?,?,?,?,?,?, @TareaId)");
            $stm->execute(array(
                                $data->__get('sTarCodigo'),
                                $data->__get('sTarNombre'),
                                $data->__get('nTarTipoFlota'),
                                $data->__get('sTarSistema_Id'),
                                $data->__get('sTarTiempoStandard'),
                                $data->__get('nTarValorVenta'),
                                $data->__get('nTarEstado'),
                                $data->__get('nTarEliminado'),
                                $data->__get('dFech_Act'),
                                $data->__get('nTarUsuario_Id')
                         ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información guardada</strong>, los datos fueron registrados correctamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Editar(Tareas $data){
        try {
            $stm = $this->pdo->prepare("CALL tar_editar(?,?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('Tareas_Id'),
                                 $data->__get('sTarCodigo'),
                                 $data->__get('sTarNombre'),
                                 $data->__get('nTarTipoFlota'),
                                 $data->__get('sTarSistema_Id'),
                                 $data->__get('sTarTiempoStandard'),                                 
                                 $data->__get('nTarValorVenta'),                                 
                                 $data->__get('nTarEstado'),                                 
                                 $data->__get('nTarEliminado'),                                 
                                 $data->__get('dFech_Act'),                                 
                                 $data->__get('nTarUsuario_Id')                                 
                                ));

            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información editada</strong>, los datos fueron editados correctamente.
                  </div>';
            echo '<script type="text/javascript">window.location="?c=Tareas&a=Index";</script>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Eliminar(Tareas $data){
        try {
            $stm = $this->pdo->prepare("CALL tar_ocultar(?,?)");
            $stm->execute(
                    array(
                            $data->__get('Tareas_Id'), 
                            $data->__get('nTarUsuario_Id')
                        ));

            echo "Se elimino correctamente";
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarTareasXSistema($Sistema_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL lis_TareasxSistema(?)");
            $stm->execute([$Sistema_Id]);
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

}
