<!DOCTYPE html>
<html lang="es">

<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta http-equiv="X-UA-Compatible" content="ie=edge">
	<title>Orden de Trabajo</title>
	<style type="text/css">
		@media print {
			@page {
				size: portrait;
				margin-left: 15px;
				margin-top: 15px;
				top: 5px;
				left: 5px;
			}
		}

		body {
			font-size: 14px;
			font-family: Helvetica;
			padding: 8px;
		}

		.tabla-cabecera {
			width: 100%;
			border-collapse: collapse;
			text-align: center;
		}

		.tabla-cabecera th, td {
			border: 1px solid #102251;
			padding: 10px;
			vertical-align: middle;
		}

		.logo {
			width: 110px;
			height: auto;
		}

		.tabla-orden {
			width: 100%;
			border-collapse: collapse;
			text-align: left;
		}

		.tabla-orden th, td {
			border: 1px solid #102251;
			padding: 10px;
			vertical-align: middle;
		}
		.th-body {
			width: 25%;
		}

		.th-label {
			background-color: #EBEBEB80;
			color: #102251;
			font-size: 12px;
		}

		.th-valor {
			color: black;
			font: 100;
			font-weight: 500;
			font-size: 12px;
		}

		.th-body-cabecera {
			background-color: #EBEBEB80;
			color: #102251;
			font-size: 15px;
			text-align: center;
		}

		.tbody-interno {
			text-align: center;
		}

		.tbody-interno-valor {
			color: black;
			font: 100;
			font-weight: 500;
			font-size: 12px;
		}


	</style>
</head>

<?php 
	$total_importe = 0;

	$subtotalinterno = 0;
	$subtotalexterno = 0;
	$subtotalrepuestos = 0;
?>

<body>
	<div>
		<table class="tabla-cabecera">
			<thead>
				<tr>
					<th style="width: 33%;"><img class="logo" src="view/librerias/dist/img/logo3.png" alt="Imagen de logo"></th>
					<th style="width: 33%; color: #102251; font-weight: bold;">ORDEN DE TRABAJO</th>
					<th style="width: 33%;"> <span style="color: #102251">N° OT :</span> <span style="color: black;"> <?= $ordenTrabajo[0]->__GET('sOtNumOrden') ?> </span></th>
				</tr>
			</thead>
		</table>
	</div>
	<div style="margin-top: 10px;">
		<table class="tabla-orden">
			<tbody>
				<tr>
					<th class="th-body th-label">VEHICULO: </th>
					<th class="th-body th-valor" colspan="3"><?= $ordenTrabajo[0]->__GET('sVehModelo') ?></th>
				</tr>
				<tr>
					<th class="th-body th-label">RUC / DNI: </th>
					<th class="th-body th-valor"> <?= $this->RucDniClienteProveedor($ordenTrabajo[0]->__GET('sOtCliente_Id')) ?></th>

					<th class="th-body th-label">FECHA Y HORA DE INICIO: </th>
					<th class="th-body th-valor"><?= date('Y-m-d', strtotime($ordenTrabajo[0]->__GET('dOtFi'))) . ' / ' . date('H:i:s', strtotime($ordenTrabajo[0]->__GET('dOtHi'))) ?></th>

				</tr>
				<tr>

					<th class="th-body th-label">CLIENTE: </th>
					<th class="th-body th-valor"> <?= $ordenTrabajo[0]->__GET('sODNombre') ?></th>

					<th class="th-body th-label">FECHA Y HORA DE TERMINO: </th>
					<th class="th-body th-valor"> <?= date('Y-m-d', strtotime($ordenTrabajo[0]->__GET('dOtFs'))) . ' / ' . date('H:i:s', strtotime($ordenTrabajo[0]->__GET('dOtHs'))) ?></th>

				</tr>
			</tbody>
		</table>
	</div>
	<div style="margin-top: 10px;">
		<table class="tabla-orden">
			<tbody>
				<tr>
					<th class="th-body th-label">TIPO DE ATENCION: </th>
					<th class="th-body th-valor"> <?= getDescripcionById($tiposAtencion, $ordenTrabajo[0]->__GET('nOtTipoAtencion')) ?></th>

					<th class="th-body th-label">KILÓMETRAJE: </th>
					<th class="th-body th-valor"> <?= $ordenTrabajo[0]->__GET('nOtKilometraje') ?></th>
				</tr>
				<tr>
					<th class="th-body th-label">TIPO DE MANTENIMIENTO: </th>
					<th class="th-body th-valor"> <?= getDescripcionById($tiposMantenimientos, $ordenTrabajo[0]->__GET('nOtTipoMant')) ?></th>

					<th class="th-body th-label">HORÓMETRO: </th>
					<th class="th-body th-valor"> <?= $ordenTrabajo[0]->__GET('nOtHorometro') ?></th>
				</tr>
				<tr>
					<th class="th-body th-label">MOTIVO DE MANTENIMIENTO: </th>
					<th class="th-body th-valor" colspan="3"> <?= $ordenTrabajo[0]->__GET('sOtMotMant') ? $ordenTrabajo[0]->__GET('sOtMotMant') : '-' ?></th>
				</tr>
				<tr>
					<th class="th-body th-label">RECOMENDACIONES DE SIGUIENTE SERVICIO: </th>
					<th class="th-body th-valor" colspan="3"> <?= $ordenTrabajo[0]->__GET('sOtRecomendaciones') ? $ordenTrabajo[0]->__GET('sOtRecomendaciones') : '-' ?></th>
				</tr>
			</tbody>
		</table>
	</div>
	<div style="margin-top: 10px;">
		<table class="tabla-orden">
			<thead>
				<tr>
					<th class="th-body-cabecera" colspan="4">TRABAJOS INTERNOS</th>
				</tr>
			</thead>
			<tbody>
				<tr>
					<th class="th-label tbody-interno" style="width: 15%;">CANTIDAD</th>
					<th class="th-label tbody-interno" style="width: 55%;">DESCRIPCION</th>
					<th class="th-label tbody-interno" style="width: 15%;">TIEMPO</th>
					<th class="th-label tbody-interno" style="width: 15%;">IMPORTE</th>
				</tr>

				<?php foreach ($ordenesInternas as $item) { 
					$importe = 0;

					$subtotalinterno += number_format($importe, 2, '.', ''); 

					$total_importe += number_format($subtotalinterno, 2, '.', '');	
				?>
					
					<tr>
						<th class="tbody-interno tbody-interno-valor" style="width: 15%;"> <?= $item->nOtiCantidad ?></th>
						<th class="tbody-interno tbody-interno-valor" style="width: 55%;"> <?= $item->sTarNombre .' - '. $item->sOtiDescripcion ?></th>
						<th class="tbody-interno tbody-interno-valor" style="width: 15%;"> <?= $item->sOtiTiempo ?></th>
						<th class="tbody-interno tbody-interno-valor" style="width: 15%;"> <?= 'S/.' . number_format($importe, 2, '.', '') ?></th>
					</tr>
				<?php } ?>

				<tr>
					<th class="th-body-cabecera" colspan="3">SUB TOTAL</th>
					<th class="th-body th-label tbody-interno-valor" style="text-align: center; font-weight: bold; font-size: 16px;"> <?= 'S/.' . number_format($subtotalinterno, 2, '.', '') ?></th>
				</tr>

			</tbody>
		</table>
	</div>
	<div style="margin-top: 10px;">
		<table class="tabla-orden">
			<thead>
				<tr>
					<th class="th-body-cabecera" colspan="4">TRABAJOS EXTERNOS</th>
				</tr>
			</thead>
			<tbody>
				<tr>
					<th class="th-label tbody-interno" style="width: 15%;">CANTIDAD</th>
					<th class="th-label tbody-interno" style="width: 55%;">DESCRIPCION</th>
					<th class="th-label tbody-interno" style="width: 15%;">PRECIO UNITARIO</th>
					<th class="th-label tbody-interno" style="width: 15%;">IMPORTE</th>
				</tr>

			<?php foreach ($detalle_trabajoExternos as $trabajoExterno) {
					foreach ($trabajoExterno as $item) {
						$subtotalexterno += number_format($item['nMovDetImporte'], 2, '.', '');

						$total_importe += number_format($subtotalexterno, 2, '.', '');
				?>
						<tr>
							<th class="tbody-interno tbody-interno-valor" style="width: 15%;"> <?= $item['nMovDetCantidad'] ?></th>
							<th class="tbody-interno tbody-interno-valor" style="width: 55%;"> <?= $item['sProSrvNombre'] ?></th>
							<th class="tbody-interno tbody-interno-valor" style="width: 15%;"> <?= number_format($item['nMovDetPrecioUnitario'], 2, '.', '') ?></th>
							<th class="tbody-interno tbody-interno-valor" style="width: 15%;"> <?= 'S/.' . number_format($item['nMovDetImporte'], 2, '.', '') ?></th>
						</tr>
				<?php }
					}
				?>

				<tr>
					<th class="th-body-cabecera" colspan="3">SUB TOTAL</th>
					<th class="th-body th-label tbody-interno-valor" style="text-align: center; font-weight: bold; font-size: 16px;"> <?= 'S/.' . number_format($subtotalexterno, 2, '.', '') ?></th>
				</tr>

			</tbody>
		</table>
	</div>
	<div style="margin-top: 10px;">
		<table class="tabla-orden">
			<thead>
				<tr>
					<th class="th-body-cabecera" colspan="4">REPUESTOS</th>
				</tr>
			</thead>
			<tbody>
				<tr>
					<th class="th-label tbody-interno" style="width: 15%;">CANTIDAD</th>
					<th class="th-label tbody-interno" style="width: 55%;">DESCRIPCION</th>
					<th class="th-label tbody-interno" style="width: 15%;">PRECIO UNITARIO</th>
					<th class="th-label tbody-interno" style="width: 15%;">IMPORTE</th>
				</tr>

				<?php foreach ($detalle_repuestos as $repuestos) {
						foreach ($repuestos as $item) {
							$subtotalrepuestos += number_format($item['nMovDetImporte'], 2, '.', '');
							$total_importe += number_format($subtotal, 2, '.', '');	
				?>
						<tr>
							<th class="tbody-interno tbody-interno-valor" style="width: 15%;"> <?= $item['nMovDetCantidad'] ?></th>
							<th class="tbody-interno tbody-interno-valor" style="width: 55%;"> <?= $item['sProSrvNombre'] ?></th>
							<th class="tbody-interno tbody-interno-valor" style="width: 15%;"> <?= number_format($item['nMovDetPrecioUnitario'], 2, '.', '') ?></th>
							<th class="tbody-interno tbody-interno-valor" style="width: 15%;"> <?= 'S/.' . number_format($item['nMovDetImporte'], 2, '.', '') ?></th>
						</tr>
				<?php } 
				} ?>

				<tr>
					<th class="th-body-cabecera" colspan="3">SUB TOTAL</th>
					<th class="th-body th-label tbody-interno-valor" style="text-align: center; font-weight: bold; font-size: 16px;"> <?= 'S/.' . number_format($subtotalrepuestos, 2, '.', '') ?></th>
				</tr>

			</tbody>
		</table>
	</div>
	<div style="margin-top: 10px;">
		<table class="tabla-orden">
			<tbody>
				<tr>
					<th class="th-body-cabecera">TOTAL</th>
					<th class="th-body th-label tbody-interno-valor" style="text-align: center; font-weight: bold; font-size: 16px;"> <?= 'S/.' . number_format($total_importe, 2, '.', '') ?></th>
				</tr>
			</tbody>
		</table>
	</div>
</body>

<script src="view/librerias/plugins/jQuery/jquery-1.11.0.min.js"></script>
<script>
	$(document).ready(function() {
		const dato = 'OT-' + '<?= $ordenTrabajo[0]->__GET("sOtNumOrden") ?>';
		document.title = dato
		window.print();
	});
</script>

</html>